﻿Public Class Confirm
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Me.siteLabel.Text = Util.GetSiteLabel
        Response.CacheControl = "no-cache"

        If Session(ScreenDef.sessionID_PID) <> ScreenDef.pageId_Confirm Then
            Response.Redirect("Entry.aspx")
        End If

        Dim entryData As EntryData = DirectCast(Session("entryData"), EntryData)

        Me.seiKanji.Text = Util.GetHtmlEncode(entryData.SeiKanji)
        Me.meiKanji.Text = Util.GetHtmlEncode(entryData.MeiKanji)
        Me.seiKana.Text = Util.GetHtmlEncode(entryData.SeiKana)
        Me.meiKana.Text = Util.GetHtmlEncode(entryData.MeiKana)
        Me.birthYear.Text = Util.GetHtmlEncode(entryData.BirthYear)
        Me.birthMonth.Text = Util.GetHtmlEncode(entryData.BirthMonth)
        Me.birthDay.Text = Util.GetHtmlEncode(entryData.BirthDay)
        Me.gender.Text = Util.GetHtmlEncode(entryData.GenderText)
        Me.zip1.Text = Util.GetHtmlEncode(entryData.Zip1)
        Me.zip2.Text = Util.GetHtmlEncode(entryData.Zip2)
        Me.address1.Text = Util.GetHtmlEncode(entryData.Address1)
        Me.address2.Text = Util.GetHtmlEncode(entryData.Address2)
        Me.address3.Text = Util.GetHtmlEncode(entryData.Address3)
        Me.address4.Text = Util.GetHtmlEncode(entryData.Address4)
        If entryData.Tel1 <> "" Then
            Me.tel.Text = Util.GetHtmlEncode(entryData.Tel1) & "-" & Util.GetHtmlEncode(entryData.Tel2) & "-" & Util.GetHtmlEncode(entryData.Tel3)
        End If
        If entryData.Mtel1 <> "" Then
            Me.mtel.Text = Util.GetHtmlEncode(entryData.Mtel1) & "-" & Util.GetHtmlEncode(entryData.Mtel2) & "-" & Util.GetHtmlEncode(entryData.Mtel3)
        End If
        Me.email.Text = Util.GetHtmlEncode(entryData.Email)
        Me.occupation.Text = Util.GetHtmlEncode(entryData.OccupationText)
    End Sub

    Protected Sub back_Click(sender As Object, e As EventArgs) Handles back.Click
        Session(ScreenDef.sessionID_PID) = ScreenDef.pageId_Entry
        Response.Redirect("Entry.aspx")
    End Sub

    Protected Sub next_Click(sender As Object, e As EventArgs) Handles [next].Click
        Dim entryData As EntryData = DirectCast(Session("entryData"), EntryData)

        'データベースに書き込む
        Dim connStr As String = Util.GetConnectionString
        Dim dc As WebFormDBDataContext = New WebFormDBDataContext(connStr)
        Try
            dc.insertRequest(entryData.SeqId, _
                             entryData.SeiKanji, _
                             entryData.MeiKanji, _
                             entryData.SeiKana, _
                             entryData.MeiKana, _
                             entryData.BirthYear & entryData.BirthMonth & entryData.BirthDay, _
                             entryData.Gender, _
                             entryData.GenderText, _
                             entryData.Zip1, _
                             entryData.Zip2, _
                             entryData.Address1, _
                             entryData.Address2, _
                             entryData.Address3, _
                             entryData.Address4, _
                             entryData.Tel1, _
                             entryData.Tel2, _
                             entryData.Tel3, _
                             entryData.Mtel1, _
                             entryData.Mtel2, _
                             entryData.Mtel3, _
                             entryData.Email, _
                             entryData.Occupation, _
                             entryData.OccupationText, _
                             entryData.IPAddress,
                             entryData.SessionId)
            dc.SubmitChanges()

            Session("entryData") = entryData
        Catch ex As Exception
            Response.Redirect("Maintenance.aspx")
        End Try

        Session(ScreenDef.sessionID_PID) = ScreenDef.pageId_Thankyou
        Response.Redirect("Thankyou.aspx")
    End Sub
End Class