﻿Public Class Entry
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Me.siteLabel.Text = Util.GetSiteLabel
        Me.testButton.Visible = (Util.GetAppSetting("TEST_MODE").ToUpper = "ON")
        Response.CacheControl = "no-cache"

        If Not Me.IsPostBack Then
            ' エラーメッセージの設定
            Me.reqValSeiKanji.ErrorMessage = "姓（漢字）は必須項目です"
            Me.reqValMeiKanji.ErrorMessage = "名（漢字）は必須項目です"
            Me.reqValSeiKana.ErrorMessage = "姓（カナ）は必須項目です"
            Me.reqValMeiKana.ErrorMessage = "名（カナ）は必須項目です"
            Me.regValSeiKana.ErrorMessage = "姓（カナ）はカタカナで入力してください"
            Me.regValSeiKana2.ErrorMessage = "姓（カナ）は20文字以内で入力してください"
            Me.regValMeiKana.ErrorMessage = "名（カナ）はカタカナで入力してください"
            Me.regValMeiKana2.ErrorMessage = "姓（カナ）は20文字以内で入力してください"

            Me.reqValBirthYear.ErrorMessage = "生年月日（年）は必須項目です"
            Me.cusValBirthYear.ErrorMessage = "生年月日（年）は4桁の数字で入力してください"
            Me.reqValBirthMonth.ErrorMessage = "生年月日（月）は必須項目です"
            Me.cusValBirthMonth.ErrorMessage = "生年月日（月）は数字で入力してください"
            Me.reqValBirthDay.ErrorMessage = "生年月日（日）は必須項目です"
            Me.cusValBirthDay.ErrorMessage = "生年月日（日）は数字で入力してください"

            Me.cusValGender.ErrorMessage = "性別を選択してください"

            Me.reqValZip1.ErrorMessage = "郵便番号（前半3桁）は必須項目です"
            Me.reqValZip2.ErrorMessage = "郵便番号（後半4桁）は必須項目です"

            Me.reqValAddress1.ErrorMessage = "都道府県は必須項目です"
            Me.reqValAddress2.ErrorMessage = "市区郡は必須項目です"
            Me.reqValAddress3.ErrorMessage = "町名・番地は必須項目です"

            Me.reqValTel1.ErrorMessage = "電話番号（市外局番）は必須項目です"
            Me.reqValTel2.ErrorMessage = "電話番号（局番）は必須項目です"
            Me.reqValTel3.ErrorMessage = "電話番号（枝番）は必須項目です"

            Me.reqValMtel1.ErrorMessage = "携帯番号（先頭）は必須項目です"
            Me.reqValMtel2.ErrorMessage = "携帯番号（中央）は必須項目です"
            Me.reqValMtel3.ErrorMessage = "携帯番号（末尾）は必須項目です"

            Me.reqValEmail1.ErrorMessage = "メールアドレスは必須項目です"
            Me.regValEmail1.ErrorMessage = "メールアドレスの形式が不正です"
            Me.compValEmail.ErrorMessage = "メールアドレスとメールアドレス（確認）が一致していません"

            Me.reqValOccupation.ErrorMessage = "職業を選択してください"

            Me.cusValWatermark.ErrorMessage = "画像認証コードが間違っています"

            ' バリデーション処理の設定
            Const kanaExp As String = "^[ ]*[ァ-ヶ|ー]+[ ]*$"
            Me.regValSeiKana.ValidationExpression = kanaExp
            Me.regValMeiKana.ValidationExpression = kanaExp
            Const lenKanaExp As String = "^[ ]*.{1,20}[ ]*$"
            Me.regValSeiKana2.ValidationExpression = lenKanaExp
            Me.regValMeiKana2.ValidationExpression = lenKanaExp
            Const mailExp As String = "^[a-zA-Z_0-9]+([-+.][a-zA-Z_0-9]+)*@[a-zA-Z_0-9]+([-.][a-zA-Z_0-9]+)*\.[a-zA-Z_0-9]+([-.][a-zA-Z_0-9]+)*$"
            Me.regValEmail1.ValidationExpression = mailExp

            ' リストコントロールに設定
            Util.AddListItem(Me.gender, "1")
            Util.AddListItem(Me.occupation, "2")

            ' セッション情報の復元
            If Not Session("entryData") Is Nothing Then
                Dim entryData As EntryData = DirectCast(Session("entryData"), EntryData)

                Me.seiKanji.Text = entryData.SeiKanji
                Me.meiKanji.Text = entryData.MeiKanji
                Me.seiKana.Text = entryData.SeiKana
                Me.meiKana.Text = entryData.MeiKana
                Me.birthYear.Text = entryData.BirthYear
                Me.birthMonth.Text = entryData.BirthMonth
                Me.birthDay.Text = entryData.BirthDay
                Me.gender.SelectedValue = entryData.Gender
                Me.zip1.Text = entryData.Zip1
                Me.zip2.Text = entryData.Zip2
                Me.address1.Text = entryData.Address1
                Me.address2.Text = entryData.Address2
                Me.address3.Text = entryData.Address3
                Me.address4.Text = entryData.Address4
                Me.tel1.Text = entryData.Tel1
                Me.tel2.Text = entryData.Tel2
                Me.tel3.Text = entryData.Tel3
                Me.mtel1.Text = entryData.Mtel1
                Me.mtel2.Text = entryData.Mtel2
                Me.mtel3.Text = entryData.Mtel3
                Me.email1.Text = entryData.Email
                Me.email2.Text = entryData.Email
                Me.occupation.SelectedValue = entryData.Occupation
            End If

            Dim rand As Random = New Random
            Dim num As Integer = rand.Next(10000, 99999)

            Session("WaterMarkNo") = num.ToString
            Me.watermark.ImageUrl = "watermark.aspx?a=" & Date.Now.Ticks.ToString

        End If
    End Sub

    Protected Sub next_Click(sender As Object, e As EventArgs) Handles [next].Click
        ' Trim
        TrimSpace()
        ' バリデーションの実行
        Page.Validate()
        ' 追加のバリデーションの実行
        CustomValidate()
        ' 画像認証のバリデーション
        WatermarkValidation()

        ' バリデーションエラーが発生したら返す
        If Not Page.IsValid Then
            Return
        End If

        ' データ格納用オブジェクトの生成
        Dim entryData As EntryData = New EntryData()

        ' データ格納用オブジェクトに設定
        entryData.SeiKanji = Me.seiKanji.Text
        entryData.MeiKanji = Me.meiKanji.Text
        entryData.SeiKana = Me.seiKana.Text
        entryData.MeiKana = Me.meiKana.Text
        entryData.BirthYear = Me.birthYear.Text
        If Me.birthMonth.Text.Length = 1 Then
            entryData.BirthMonth = "0" & Me.birthMonth.Text
        Else
            entryData.BirthMonth = Me.birthMonth.Text
        End If
        If Me.birthDay.Text.Length = 1 Then
            entryData.BirthDay = "0" & Me.birthDay.Text
        Else
            entryData.BirthDay = Me.birthDay.Text
        End If

        entryData.Gender = Me.gender.SelectedValue
        entryData.GenderText = Util.GetDataName("1", entryData.Gender)

        entryData.Zip1 = Me.zip1.Text
        entryData.Zip2 = Me.zip2.Text

        entryData.Address1 = Me.address1.Text
        entryData.Address2 = Me.address2.Text
        entryData.Address3 = Me.address3.Text
        entryData.Address4 = Me.address4.Text

        entryData.Tel1 = Me.tel1.Text
        entryData.Tel2 = Me.tel2.Text
        entryData.Tel3 = Me.tel3.Text

        entryData.Mtel1 = Me.mtel1.Text
        entryData.Mtel2 = Me.mtel2.Text
        entryData.Mtel3 = Me.mtel3.Text

        entryData.Email = Me.email1.Text

        entryData.Occupation = Me.occupation.SelectedValue
        entryData.OccupationText = Util.GetDataName("2", entryData.Occupation)

        entryData.IPAddress = System.Web.HttpContext.Current.Request.UserHostAddress
        entryData.SessionId = Session.SessionID

        ' セッションに格納
        Session("entryData") = entryData

        Session(ScreenDef.sessionID_PID) = ScreenDef.pageId_Confirm

        ' 確認画面へ遷移
        Response.Redirect("Confirm.aspx")
    End Sub

    Private Sub TrimSpace()
        Me.seiKanji.Text = Me.seiKanji.Text.Trim
        Me.meiKanji.Text = Me.meiKanji.Text.Trim
        Me.seiKana.Text = Me.seiKana.Text.Trim
        Me.meiKana.Text = Me.meiKana.Text.Trim
        Me.birthYear.Text = Me.birthYear.Text.Trim
        Me.birthMonth.Text = Me.birthMonth.Text.Trim
        Me.birthDay.Text = Me.birthDay.Text.Trim
        Me.zip1.Text = Me.zip1.Text.Trim
        Me.zip2.Text = Me.zip2.Text.Trim
        Me.address1.Text = Me.address1.Text.Trim
        Me.address2.Text = Me.address2.Text.Trim
        Me.address3.Text = Me.address3.Text.Trim
        Me.address4.Text = Me.address4.Text.Trim
        Me.tel1.Text = Me.tel1.Text.Trim
        Me.tel2.Text = Me.tel2.Text.Trim
        Me.tel3.Text = Me.tel3.Text.Trim
        Me.mtel1.Text = Me.mtel1.Text.Trim
        Me.mtel2.Text = Me.mtel2.Text.Trim
        Me.mtel3.Text = Me.mtel3.Text.Trim
        Me.email1.Text = Me.email1.Text.Trim
        Me.email2.Text = Me.email2.Text.Trim
    End Sub

    Private Sub CustomValidate()
        'gender 
        If gender.SelectedItem Is Nothing Then
            Me.cusValGender.IsValid = False
        End If

        'tel check
        If (tel1.Text = "" AndAlso tel2.Text = "" AndAlso tel3.Text = "") And (mtel1.Text = "" AndAlso mtel2.Text = "" AndAlso mtel3.Text = "") Then
            Me.cusValTel.IsValid = False
            Me.cusValTel.ErrorMessage = "自宅電話番号か携帯電話番号のどちらかは入力してください"

            Me.reqValTel1.IsValid = True
            Me.reqValTel2.IsValid = True
            Me.reqValTel3.IsValid = True
            Me.reqValMtel1.IsValid = True
            Me.reqValMtel2.IsValid = True
            Me.reqValMtel3.IsValid = True
        End If

        If Me.tel1.Text = "" And Me.tel2.Text = "" And Me.tel3.Text = "" Then
            Me.reqValTel1.IsValid = True
            Me.reqValTel2.IsValid = True
            Me.reqValTel3.IsValid = True
        End If

        If Me.mtel1.Text = "" And Me.mtel2.Text = "" And Me.mtel3.Text = "" Then
            Me.reqValMtel1.IsValid = True
            Me.reqValMtel2.IsValid = True
            Me.reqValMtel3.IsValid = True
        End If


        'birthdate 
        If Me.reqValBirthYear.IsValid AndAlso Me.reqValBirthMonth.IsValid AndAlso Me.reqValBirthDay.IsValid Then
            If Not IsDate(Me.birthYear.Text & "/" & Me.birthMonth.Text & "/" & Me.birthDay.Text) Then
                Me.cusValBirthDay.IsValid = False
                Me.cusValBirthDay.ErrorMessage = "生年月日が不正です"
            End If
        End If

        'email
        If Trim(email1.Text).Length > 50 Then
            Me.reqValEmail1.IsValid = False
        End If
    End Sub

    ' CustomValidationのサーバーサイド処理
    Private Sub CustomValidate_ServerValidate(ByVal source As System.Object, ByVal args As System.Web.UI.WebControls.ServerValidateEventArgs) Handles _
        cusValSeiKanji.ServerValidate, _
        cusValMeiKanji.ServerValidate, _
        cusValZip1.ServerValidate, _
        cusValZip2.ServerValidate, _
        cusValAddress1.ServerValidate, _
        cusValAddress2.ServerValidate, _
        cusValAddress3.ServerValidate, _
        cusValAddress4.ServerValidate, _
        cusValTel1.ServerValidate, _
        cusValTel2.ServerValidate, _
        cusValTel3.ServerValidate, _
        cusValMtel1.ServerValidate, _
        cusValMtel2.ServerValidate, _
        cusValMtel3.ServerValidate

        Dim cusVal As CustomValidator = DirectCast(source, UI.WebControls.CustomValidator)

        Select Case cusVal.ID
            Case Me.cusValSeiKanji.ID
                If Util.IncludeHarfCharacter(Me.seiKanji.Text) Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "姓（漢字）に半角文字は使えません"
                ElseIf Util.IncludeZenNumeric(Me.seiKanji.Text) Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "姓（漢字）に全角数字は使えません"
                ElseIf Util.IncludeZenAlphabet(Me.seiKanji.Text) Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "姓（漢字）に全角アルファベットは使えません"
                ElseIf Util.IncludeSpecialCharacter(Me.seiKanji.Text) Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "姓（漢字）に機種依存文字は使えません"
                ElseIf Me.seiKanji.Text.Length > 20 Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "姓（漢字）は20文字以内で入力してください"
                End If
            Case Me.cusValMeiKanji.ID
                If Util.IncludeHarfCharacter(Me.meiKanji.Text) Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "名（漢字）に半角文字は使えません"
                ElseIf Util.IncludeZenNumeric(Me.meiKanji.Text) Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "名（漢字）に全角数字は使えません"
                ElseIf Util.IncludeZenAlphabet(Me.meiKanji.Text) Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "名（漢字）に全角アルファベットは使えません"
                ElseIf Util.IncludeSpecialCharacter(Me.meiKanji.Text) Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "名（漢字）に機種依存文字は使えません"
                ElseIf Me.meiKanji.Text.Length > 20 Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "名（漢字）は20文字以内で入力してください"
                End If
            Case Me.cusValZip1.ID
                If Not Util.IsNumeric(Me.zip1.Text) Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "郵便番号（前半3桁）は数字で入力してください"
                ElseIf Me.zip1.Text.Length <> 3 Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "郵便番号（前半3桁）は3桁の数字で入力してください"
                End If
            Case Me.cusValZip2.ID
                If Not Util.IsNumeric(Me.zip2.Text) Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "郵便番号（前半4桁）は数字で入力してください"
                ElseIf Me.zip2.Text.Length <> 4 Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "郵便番号（前半4桁）は4桁の数字で入力してください"
                End If
            Case Me.cusValAddress1.ID
                If Util.IncludeHarfCharacter(Me.address1.Text) Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "都道府県に半角文字は使えません"
                ElseIf Util.IncludeSpecialCharacter(Me.address1.Text) Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "都道府県に機種依存文字は使えません"
                ElseIf Me.address1.Text.Length > 30 Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "都道府県は30文字以内で入力してください"
                End If
            Case Me.cusValAddress2.ID
                If Util.IncludeHarfCharacter(Me.address2.Text) Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "市区郡に半角文字は使えません"
                ElseIf Util.IncludeSpecialCharacter(Me.address2.Text) Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "市区郡に機種依存文字は使えません"
                ElseIf Me.address2.Text.Length > 30 Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "市区郡は30文字以内で入力してください"
                End If
            Case Me.cusValAddress3.ID
                If Util.IncludeHarfCharacter(Me.address3.Text) Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "町名・番地に半角文字は使えません"
                ElseIf Util.IncludeSpecialCharacter(Me.address3.Text) Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "町名・番地に機種依存文字は使えません"
                ElseIf Me.address3.Text.Length > 40 Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "町名・番地は40文字以内で入力してください"
                End If
            Case Me.cusValAddress4.ID
                If Util.IncludeHarfCharacter(Me.address4.Text) Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "アパート・マンション名に半角文字は使えません"
                ElseIf Util.IncludeSpecialCharacter(Me.address4.Text) Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "アパート・マンション名に機種依存文字は使えません"
                ElseIf Me.address4.Text.Length > 40 Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "アパート・マンション名は40文字以内で入力してください"
                End If
            Case Me.cusValTel1.ID
                If Not Util.IsNumeric(Me.tel1.Text) Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "電話番号（市外局番）は数字で入力してください"
                ElseIf Me.tel1.Text.Length > 10 Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "電話番号（市外局番）は10桁以内の数字で入力してください"
                End If
            Case Me.cusValTel2.ID
                If Not Util.IsNumeric(Me.tel2.Text) Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "電話番号（局番）は数字で入力してください"
                ElseIf Me.tel2.Text.Length > 10 Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "電話番号（局番）は10桁以内の数字で入力してください"
                End If
            Case Me.cusValTel3.ID
                If Not Util.IsNumeric(Me.tel3.Text) Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "電話番号（枝番）は数字で入力してください"
                ElseIf Me.tel3.Text.Length > 10 Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "電話番号（枝番）は10桁以内の数字で入力してください"
                End If
            Case Me.cusValMtel1.ID
                If Not Util.IsNumeric(Me.mtel1.Text) Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "携帯番号（前半3桁）は数字で入力してください"
                ElseIf Me.mtel1.Text.Length <> 3 Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "携帯番号（前半3桁）は3桁の数字で入力してください"
                End If
            Case Me.cusValMtel2.ID
                If Not Util.IsNumeric(Me.mtel2.Text) Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "携帯番号（中央4桁）は数字で入力してください"
                ElseIf Me.mtel2.Text.Length <> 4 Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "携帯番号（中央4桁）は4桁の数字で入力してください"
                End If
            Case Me.cusValMtel3.ID
                If Not Util.IsNumeric(Me.mtel3.Text) Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "携帯番号（末尾4桁）は数字で入力してください"
                ElseIf Me.mtel3.Text.Length <> 4 Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "携帯番号（末尾4桁）は4桁の数字で入力してください"
                End If


        End Select
    End Sub

    Private Sub WatermarkValidation()
        Dim num As String = Session("WaterMarkNo")
        If Me.wmnum.Text.Trim <> num Then
            Dim is5time As Boolean = Me.Is5time
            If is5time Then
                Me.Response.Redirect("WatermarkError.aspx")
            End If

            If Me.wmnum.Text.Trim = "" Then
                Me.cusValWatermark.IsValid = True
            Else
                Me.cusValWatermark.IsValid = False
            End If

            Exit Sub
        End If
        Me.Session(sessionId5time) = 0
        Me.cusValWatermark.IsValid = True
    End Sub

    Const sessionId5time As String = "WMInputCt"

    Private Function Is5time() As Boolean
        Dim ct As Integer = IIf(Me.Session(sessionId5time) Is Nothing, "0", Me.Session(sessionId5time))
        If ct > (Me.GetCheckTimes) - 2 Then
            Me.Session(sessionId5time) = 0
            Return True
        End If
        Me.Session(sessionId5time) = ct + 1
        Return False
    End Function

    Private Function GetCheckTimes() As Integer
        Dim str1 As String = Util.GetAppSetting("WatermarkAuthMaxAttempt")
        If str1 Is Nothing Then Return 5
        If Not IsNumeric(str1) Then Return 5
        Return CInt(str1)

    End Function

    Protected Sub testButton_Click(sender As Object, e As EventArgs) Handles testButton.Click
        Me.seiKanji.Text = "山田"
        Me.meiKanji.Text = "太郎"
        Me.seiKana.Text = "ヤマダ"
        Me.meiKana.Text = "タロウ"
        Me.birthYear.Text = "1975"
        Me.birthMonth.Text = "05"
        Me.birthDay.Text = "26"
        Me.gender.SelectedValue = "1"
        Me.zip1.Text = "100"
        Me.zip2.Text = "0001"
        Me.address1.Text = "東京都"
        Me.address2.Text = "千代田区"
        Me.address3.Text = "千代田１－２－３"
        Me.address4.Text = "千代田マンション１０１"
        Me.tel1.Text = "03"
        Me.tel2.Text = "0000"
        Me.tel3.Text = "0000"
        Me.mtel1.Text = "090"
        Me.mtel2.Text = "0000"
        Me.mtel3.Text = "0000"
        Me.email1.Text = "test@test.com"
        Me.email2.Text = "test@test.com"
        Me.occupation.SelectedValue = "1"
        Me.wmnum.Text = Session("WaterMarkNo")
    End Sub
End Class