﻿Public Class Detail
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ' ログイン情報の取得
        Dim accountInfo As AccountInfo = DirectCast(Session("AccountInfo"), AccountInfo)

        ' Write権限のときのみステータス更新ボタンを表示
        If accountInfo.roleWrite Then
            Me.statusChange.Visible = True
        Else
            Me.statusChange.Visible = False
        End If

        ' ログイン情報がないときはエラー
        If accountInfo Is Nothing Then
            Response.Redirect("Maintenance.aspx")
        End If

        ' 権限がないときはエラー
        If Not (accountInfo.roleRead Or accountInfo.roleWrite) Then
            Response.Redirect("Maintenance.aspx")
        End If


        If Not Me.IsPostBack Then

            ' IDの取得
            Dim id As String

            id = Request.QueryString("id")

            If id Is Nothing Then
                id = Session("StatusChangeSeqId")
            Else
                Session("StatusChangeSeqId") = id
            End If
            ' IDがないときはエラー
            If id Is Nothing Then
                Response.Redirect("Maintenance.aspx")
            End If

            ' コネクションストリングの取得
            Dim connStr As String = Util.GetConnectionString
            ' データコンテキストの取得
            Dim dc As WebFormDBDataContext = New WebFormDBDataContext(connStr)

            ' モデルの宣言
            Dim model As DBModelRequestData = New DBModelRequestData
            Dim model2 As DBModelStatusHistory = New DBModelStatusHistory

            ' 申込データの取得
            model.RequestData = From t In dc.GetTable(Of RequestData)() Select t Where t.SEQ_ID = id

            ' 申込データが見つからないときはエラー
            If model.RequestData.Count = 0 Then
                Response.Redirect("Maintenance.aspx")
            End If

            ' ステータス更新履歴の取得
            model2.StatusHistory = From t In dc.GetTable(Of StatusHistory)() Select t Where t.SEQ_ID = id

            ' 表示データを設定
            Me.seqId.Text = model.RequestData.First.SEQ_ID.ToString
            Me.status.Text = model.RequestData.First.STATUS_TEXT.ToString
            Me.seiKanji.Text = model.RequestData.First.SEI_KANJI.ToString
            Me.meiKanji.Text = model.RequestData.First.MEI_KANJI.ToString
            Me.seiKana.Text = model.RequestData.First.SEI_KANA.ToString
            Me.meiKana.Text = model.RequestData.First.MEI_KANA.ToString
            Me.birthDate.Text = model.RequestData.First.BIRTH_DATE.ToString
            Me.gender.Text = model.RequestData.First.GENDER_TEXT.ToString
            Me.zip1.Text = model.RequestData.First.ZIP1.ToString
            Me.zip2.Text = model.RequestData.First.ZIP2.ToString
            Me.address1.Text = model.RequestData.First.ADDRESS1.ToString
            Me.address2.Text = model.RequestData.First.ADDRESS2.ToString
            Me.address3.Text = model.RequestData.First.ADDRESS3.ToString
            Me.address4.Text = model.RequestData.First.ADDRESS4.ToString
            If model.RequestData.First.TEL1.ToString <> "" Then
                Me.tel.Text = model.RequestData.First.TEL1.ToString & "-" & model.RequestData.First.TEL2.ToString & "-" & model.RequestData.First.TEL3.ToString
            End If
            If model.RequestData.First.M_TEL1.ToString <> "" Then
                Me.mtel.Text = model.RequestData.First.M_TEL1.ToString & "-" & model.RequestData.First.M_TEL2.ToString & "-" & model.RequestData.First.M_TEL3.ToString
            End If
            Me.email.Text = model.RequestData.First.E_MAIL.ToString
            Me.occupation.Text = model.RequestData.First.OCCUPATION_TEXT.ToString
            Me.ipAddress.Text = model.RequestData.First.IP_ADDRESS.ToString
            Me.sessionId.Text = model.RequestData.First.SESSION_ID.ToString

            Session("StatusChangeOldStatus") = model.RequestData.First.STATUS.ToString

            ' ステータス更新履歴の設定
            Me.statusList.DataSource = model2.StatusHistory
            Me.statusList.DataBind()

        End If
    End Sub

    Protected Sub back_Click(sender As Object, e As EventArgs) Handles back.Click
        ' データ検索画面へ戻る
        Response.Redirect("Status.aspx")
    End Sub

    Protected Sub statusChange_Click(sender As Object, e As EventArgs) Handles statusChange.Click
        ' セッションのクリア
        Session("StatusChangeNewStatus") = Nothing
        Session("StatusChangeNewComment") = Nothing
        ' ステータス更新画面へ遷移
        Response.Redirect("StatusChange.aspx")
    End Sub
End Class