﻿Public Class EditPassword
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ' ログイン情報の取得
        Dim accountInfo As AccountInfo = DirectCast(Session("AccountInfo"), AccountInfo)

        ' ログイン情報がないときはエラー
        If accountInfo Is Nothing Then
            Response.Redirect("Maintenance.aspx")
        End If

        ' 権限がないときはエラー
        If Not accountInfo.roleUserManager Then
            Response.Redirect("Maintenance.aspx")
        End If

        If Not Me.IsPostBack Then
            ' エラーメッセージの設定
            Me.compValPassword.ErrorMessage = "パスワードおよびパスワード（確認）が異なります"

            ' IDの取得
            Dim id As String

            id = Request.QueryString("id")
            If id Is Nothing Then
                id = Session("EditPasswordOperatorId")
            Else
                Session("EditPasswordOperatorId") = id

                Session("EditPasswordPassword") = Nothing
            End If

            ' IDがないときはエラー
            If id Is Nothing Then
                Response.Redirect("Maintenance.aspx")
            End If

            ' コネクションストリングの取得
            Dim connStr As String = Util.GetConnectionString
            ' データコンテキストの取得
            Dim dc As WebFormDBDataContext = New WebFormDBDataContext(connStr)
            ' モデルの生成
            Dim model As DBModelUserMst = New DBModelUserMst
            ' ユーザ情報の取得
            model.UserMst = From t In dc.GetTable(Of MstUser)() Select t Where t.OPERATOR_ID = id

            ' ユーザ情報が見つからないときはエラー
            If model.UserMst.Count = 0 Then
                Response.Redirect("Maintenance.aspx")
            End If

            Me.operatorId.Text = model.UserMst.First.OPERATOR_ID.ToString
        End If
    End Sub

    Protected Sub back_Click(sender As Object, e As EventArgs) Handles back.Click
        Response.Redirect("UserManager.aspx")
    End Sub

    Protected Sub next_Click(sender As Object, e As EventArgs) Handles [next].Click
        Page.Validate()

        If Not Page.IsValid Then
            Return
        End If

        Session("EditPasswordPassword") = Me.password1.Text

        Response.Redirect("EditPasswordConfirm.aspx")
    End Sub

    Private Sub CustomValidate_ServerValidate(ByVal source As System.Object, ByVal args As System.Web.UI.WebControls.ServerValidateEventArgs) Handles _
        cusValPassword1.ServerValidate

        Dim cusVal As CustomValidator = DirectCast(source, UI.WebControls.CustomValidator)

        Select Case cusVal.ID

            Case cusValPassword1.ID
                If Not Util.ValidatePassword(Me.password1.Text) Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "パスワードは半角英数字6文字-20文字で入力してください。また、英大文字、英小文字、数字の3種類の文字を含む必要があります"
                End If
        End Select
    End Sub
End Class