﻿Public Class EditPasswordConfirm
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ' ログイン情報の取得
        Dim accountInfo As AccountInfo = DirectCast(Session("AccountInfo"), AccountInfo)

        ' ログイン情報が見つからないときはエラー
        If accountInfo Is Nothing Then
            Response.Redirect("Maintenance.aspx")
        End If

        ' 権限がないときはエラー
        If Not accountInfo.roleUserManager Then
            Response.Redirect("Maintenance.aspx")
        End If

        ' セッションから表示データの取得
        Me.operatorId.Text = Util.GetHtmlEncode(Session("EditPasswordOperatorId"))
        Me.password.Text = Util.GetMaskString(Session("EditPasswordPassword"))
    End Sub

    Protected Sub save_Click(sender As Object, e As EventArgs) Handles save.Click
        ' コネクションストリングの取得
        Dim connStr As String = Util.GetConnectionString
        ' データコンテキストの取得
        Dim dc As WebFormDBDataContext = New WebFormDBDataContext(connStr)

        Try
            ' 入力パスワードの暗号化
            Dim encryptPassword As String = Crypt.EncryptSHA256(Session("EditPasswordPassword"))

            ' パスワードの更新
            dc.updatePassword(Session("EditPasswordOperatorId"), _
                            True,
                            encryptPassword
                            )

            dc.SubmitChanges()
        Catch ex As Exception
            Response.Redirect("Maintenance.aspx")
        End Try

        ' セッションのクリア
        Session("EditPasswordOperatorId") = Nothing
        Session("EditPasswordPassword") = Nothing
        Response.Redirect("MessageBox.aspx")
    End Sub

    Protected Sub back_Click(sender As Object, e As EventArgs) Handles back.Click
        Response.Redirect("EditPassword.aspx")
    End Sub
End Class