﻿Public Class EditUserConfirm
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ' ログイン情報の取得
        Dim accountInfo As AccountInfo = DirectCast(Session("AccountInfo"), AccountInfo)

        ' ログイン情報が見つからないときはエラー
        If accountInfo Is Nothing Then
            Response.Redirect("Maintenance.aspx")
        End If

        ' 権限がないときはエラー
        If Not accountInfo.roleUserManager Then
            Response.Redirect("Maintenance.aspx")
        End If

        ' 表示データをセッションから取得
        Me.operatorId.Text = Util.GetHtmlEncode(Session("EditUserOperatorId"))
        Me.operatorName.Text = Util.GetHtmlEncode(Session("EditUserOperatorName"))
        Dim role As String = ""
        Dim array As String() = Session("EditUserRole").ToString.Split(",")

        For i As Integer = 0 To array.Length - 1
            role = role & Util.GetDataName("4", array(i)) & ","
        Next

        If role.EndsWith(",") Then
            role = role.Substring(0, role.Length - 1)
        End If

        Me.role.Text = role

        Me.lock.Text = Session("EditUserLock")
        Me.disabled.Text = Session("EditUserDisabled")


    End Sub

    Protected Sub back_Click(sender As Object, e As EventArgs) Handles back.Click
        Response.Redirect("EditUser.aspx")
    End Sub

    Protected Sub save_Click(sender As Object, e As EventArgs) Handles save.Click
        ' コネクションストリングの取得
        Dim connStr As String = Util.GetConnectionString
        ' データコンテキストの取得
        Dim dc As WebFormDBDataContext = New WebFormDBDataContext(connStr)
        ' ロールテキストの設定
        Dim role As String = ""
        Dim array As String() = Session("EditUserRole").ToString.Split(",")

        For i As Integer = 0 To array.Length - 1
            role = role & Util.GetDataName("4", array(i)) & ","
        Next

        If role.EndsWith(",") Then
            role = role.Substring(0, role.Length - 1)
        End If

        Try
            ' ユーザ情報の更新
            dc.updateUserMst(Session("EditUserOperatorId"), _
                                Session("EditUserOperatorName"), _
                                Session("EditUserRole"), _
                                role, _
                                CBool(Session("EditUserLock")), _
                                CBool(Session("EditUserDisabled")))
            dc.SubmitChanges()
        Catch ex As Exception
            Response.Redirect("Maintenance.aspx")
        End Try

        ' セッションのクリア
        Session("EditUserOperatorId") = Nothing
        Session("EditUserOperatorName") = Nothing
        Session("EditUserRole") = Nothing
        Session("EditUserLock") = Nothing
        Session("EditUserDisabled") = Nothing

        Response.Redirect("MessageBox.aspx")
    End Sub
End Class