﻿Public Class NewUserConfirm
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ' ログイン情報を取得
        Dim accountInfo As AccountInfo = DirectCast(Session("AccountInfo"), AccountInfo)

        ' ログイン情報がないときはエラー
        If accountInfo Is Nothing Then
            Response.Redirect("Maintenance.aspx")
        End If

        ' 権限がないときはエラー
        If Not accountInfo.roleUserManager Then
            Response.Redirect("Maintenance.aspx")
        End If

        ' 表示データをセッションから取得
        Me.operatorId.Text = Util.GetHtmlEncode(Session("NewUserOperatorId"))
        Me.operatorName.Text = Util.GetHtmlEncode(Session("NewUserOperatorName"))
        Dim role As String = ""
        Dim array As String() = Session("NewUserRole").ToString.Split(",")

        For i As Integer = 0 To array.Length - 1
            role = role & Util.GetDataName("4", array(i)) & ","
        Next

        If role.EndsWith(",") Then
            role = role.Substring(0, role.Length - 1)
        End If

        Me.role.Text = role

        Me.password.Text = Util.GetMaskString(Session("NewUserPassword"))
    End Sub

    Protected Sub back_Click(sender As Object, e As EventArgs) Handles back.Click
        Response.Redirect("NewUser.aspx")
    End Sub

    Protected Sub save_Click(sender As Object, e As EventArgs) Handles save.Click
        'コネクションストリングの取得
        Dim connStr As String = Util.GetConnectionString
        ' データコンテキストの取得
        Dim dc As WebFormDBDataContext = New WebFormDBDataContext(connStr)

        ' ロールテキストの生成
        Dim role As String = ""
        Dim array As String() = Session("NewUserRole").ToString.Split(",")

        For i As Integer = 0 To array.Length - 1
            role = role & Util.GetDataName("4", array(i)) & ","
        Next

        If role.EndsWith(",") Then
            role = role.Substring(0, role.Length - 1)
        End If

        Try
            ' 暗号化したパスワードの取得
            Dim encryptPassword As String = Crypt.EncryptSHA256(Session("NewUserPassword"))

            ' ユーザマスタに登録
            dc.insertUserMst(Session("NewUserOperatorId"), _
                            encryptPassword,
                            Session("NewUserOperatorName"), _
                            Session("NewUserRole"),
                            role)

            dc.SubmitChanges()
        Catch ex As Exception
            Response.Redirect("Maintenance.aspx")
        End Try

        ' セッションのクリア
        Session("NewUserOperatorId") = Nothing
        Session("NewUserOperatorName") = Nothing
        Session("NewUserRole") = Nothing
        Session("NewUserPassword") = Nothing
        Response.Redirect("MessageBox.aspx")
    End Sub
End Class