﻿Public Class PasswordChange
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Not Me.IsPostBack Then
            ' エラーメッセージの設定
            Me.reqValOperatorId.ErrorMessage = "オペレータIDを入力してください"
            Me.reqValOldPassword.ErrorMessage = "現在のパスワードを入力してください"
            Me.reqValNewPassword.ErrorMessage = "新パスワードを入力してください"
            Me.compValPassword.ErrorMessage = "新パスワードおよび新パスワード（確認）が異なります"
        End If

    End Sub

    Protected Sub back_Click(sender As Object, e As EventArgs) Handles back.Click
        ' ログイン画面へ戻る
        Response.Redirect("Login.aspx")
    End Sub

    Protected Sub next_Click(sender As Object, e As EventArgs) Handles [next].Click
        ' バリデーションの実行
        Page.Validate()

        ' バリデーションエラーが発生した時は何もしない
        If Not Page.IsValid Then
            Return
        End If

        ' セッションの保存
        Session("PasswordChangeOperatorId") = Me.operatorId.Text
        Session("PasswordChangeOldPassword") = Me.oldPassword.Text
        Session("PasswordChangeNewPassword") = Me.newPassword1.Text

        ' 確認画面へ遷移
        Response.Redirect("PasswordChangeConfirm.aspx")
    End Sub

    ' カスタムバリデーションの実行
    Private Sub CustomValidate_ServerValidate(ByVal source As System.Object, ByVal args As System.Web.UI.WebControls.ServerValidateEventArgs) Handles _
        cusValOldPassword.ServerValidate, _
         cusValNewPassword.ServerValidate

        Dim cusVal As CustomValidator = DirectCast(source, UI.WebControls.CustomValidator)

        Select Case cusVal.ID

            Case cusValOldPassword.ID
                ' 現在のパスワードの判定
                Dim connStr As String = Util.GetConnectionString
                Dim dc As WebFormDBDataContext = New WebFormDBDataContext(connStr)
                Dim model As DBModelUserMst = New DBModelUserMst

                model.UserMst = From t In dc.GetTable(Of MstUser)() Where t.OPERATOR_ID = Me.operatorId.Text

                Dim encryptPassword As String = Crypt.EncryptSHA256(Me.oldPassword.Text)

                If model.UserMst.Count = 0 Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "オペレータIDまたは現在のパスワードが間違っています"
                ElseIf model.UserMst.First.ENCRYPTED_PASSWORD <> encryptPassword Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "オペレータIDまたは現在のパスワードが間違っています"
                End If

            Case cusValNewPassword.ID
                ' 新パスワードの判定
                If Not Util.ValidatePassword(Me.newPassword1.Text) Then
                    args.IsValid = False
                    cusVal.ErrorMessage = "新パスワードは半角英数字6文字-20文字で入力してください。また、英大文字、英小文字、数字の3種類の文字を含む必要があります"
                End If
        End Select
    End Sub
End Class