﻿Public Class PasswordChangeConfirm
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ' セッションから表示データの取得
        Me.operatorId.Text = Util.GetHtmlEncode(Session("PasswordChangeOperatorId"))
        Me.oldPassword.Text = Util.GetMaskString(Session("PasswordChangeOldPassword"))
        Me.newPassword.Text = Util.GetMaskString(Session("PasswordChangeNewPassword"))
    End Sub

    Protected Sub back_Click(sender As Object, e As EventArgs) Handles back.Click
        ' パスワード更新画面へ遷移
        Response.Redirect("PasswordChange.aspx")
    End Sub

    Protected Sub save_Click(sender As Object, e As EventArgs) Handles save.Click
        ' コネクションストリングの取得
        Dim connStr As String = Util.GetConnectionString
        ' データコンテキストの生成
        Dim dc As WebFormDBDataContext = New WebFormDBDataContext(connStr)

        Try
            ' 入力パスワードの暗号化
            Dim encryptPassword As String = Crypt.EncryptSHA256(Session("PasswordChangeNewPassword"))

            ' パスワードの更新
            dc.updatePassword(Session("PasswordChangeOperatorId"), _
                            False,
                            encryptPassword
                            )

            dc.SubmitChanges()
        Catch ex As Exception
            Response.Redirect("Maintenance.aspx")
        End Try

        ' セッションのクリア
        Session("PasswordChangeOperatorId") = Nothing
        Session("PasswordChangeOldPassword") = Nothing
        Session("PasswordChangeNewPassword") = Nothing

        ' メッセージボックスの表示
        Response.Redirect("MessageBox.aspx")
    End Sub
End Class