﻿Public Class StatusChange
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ' ログイン情報の取得
        Dim accountInfo As AccountInfo = DirectCast(Session("AccountInfo"), AccountInfo)

        ' ログイン情報がないときはエラー
        If accountInfo Is Nothing Then
            Response.Redirect("Maintenance.aspx")
        End If

        ' 権限がないときはエラー
        If Not accountInfo.roleWrite Then
            Response.Redirect("Maintenance.aspx")
        End If

        If Not Me.IsPostBack Then
            ' リストコントロールに設定
            Util.AddListItem(Me.status, "3")

            Me.seqId.Text = Session("StatusChangeSeqId")

            If Not Session("StatusChangeNewStatus") Is Nothing Then
                Me.status.SelectedValue = Session("StatusChangeNewStatus")
                Me.comment.Text = Session("StatusChangeComment")
            Else
                Me.status.SelectedValue = Session("StatusChangeOldStatus")
            End If

        End If
    End Sub

    Protected Sub back_Click(sender As Object, e As EventArgs) Handles back.Click
        ' 詳細画面へ戻る
        Response.Redirect("Detail.aspx")
    End Sub

    Protected Sub next_Click(sender As Object, e As EventArgs) Handles [next].Click
        ' バリデーションの実行
        Page.Validate()

        ' バリデーションエラーが発生した時は何もしない
        If Not Page.IsValid Then
            Return
        End If

        ' セッションの格納
        Session("StatusChangeNewStatus") = Me.status.SelectedValue
        Session("StatusChangeComment") = Me.comment.Text

        ' ステータス更新確認画面へ遷移
        Response.Redirect("StatusChangeConfirm.aspx")
    End Sub

    ' カスタムバリデーション
    Private Sub CustomValidate_ServerValidate(ByVal source As System.Object, ByVal args As System.Web.UI.WebControls.ServerValidateEventArgs) Handles cusValComment.ServerValidate
        Dim cusVal As CustomValidator = DirectCast(source, UI.WebControls.CustomValidator)

        If Util.IncludeSpecialCharacter(Me.comment.Text) Then
            args.IsValid = False
            cusVal.ErrorMessage = "コメントに機種依存文字は使えません"
        ElseIf Me.comment.Text.Length > 256 Then
            args.IsValid = False
            cusVal.ErrorMessage = "コメントは256文字以内で入力してください"
        End If
    End Sub
End Class