﻿Public Class StatusChangeConfirm
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ' ログイン情報の取得
        Dim accountInfo As AccountInfo = DirectCast(Session("AccountInfo"), AccountInfo)

        ' ログイン情報がないときはエラー
        If accountInfo Is Nothing Then
            Response.Redirect("Maintenance.aspx")
        End If

        ' 権限がないときはエラー
        If Not accountInfo.roleWrite Then
            Response.Redirect("Maintenance.aspx")
        End If

        If Not Me.IsPostBack Then
            ' 表示データを設定
            Me.seqId.Text = Session("StatusChangeSeqId")
            Me.oldStatus.Text = Util.GetDataName("3", Session("StatusChangeOldStatus"))
            Me.newStatus.Text = Util.GetDataName("3", Session("StatusChangeNewStatus"))
            Me.comment.Text = Util.GetHtmlEncode(Session("StatusChangeComment"))
        End If
    End Sub

    Protected Sub back_Click(sender As Object, e As EventArgs) Handles back.Click
        Response.Redirect("StatusChange.aspx")
    End Sub

    Protected Sub save_Click(sender As Object, e As EventArgs) Handles save.Click
        ' コネクションストリングの取得
        Dim connStr As String = Util.GetConnectionString
        ' データコンテキストの取得
        Dim dc As WebFormDBDataContext = New WebFormDBDataContext(connStr)
        ' ログイン情報の取得
        Dim accountInfo As AccountInfo = DirectCast(Session("AccountInfo"), AccountInfo)

        Try
            ' ステータス更新履歴を保存
            dc.insertStatusHistory(CInt(Session("StatusChangeSeqId")), _
                                CInt(Session("StatusChangeOldStatus")), _
                                Util.GetDataName("3", Session("StatusChangeOldStatus")), _
                                CInt(Session("StatusChangeNewStatus")), _
                                Util.GetDataName("3", Session("StatusChangeNewStatus")), _
                                Session("StatusChangeComment"), _
                                accountInfo.operatorId)
            dc.SubmitChanges()
        Catch ex As Exception
            Response.Redirect("Maintenance.aspx")
        End Try

        ' セッションをクリア
        Session("StatusChangeSeqId") = Nothing
        Session("StatusChangeOldStatus") = Nothing
        Session("StatusChangeNewStatus") = Nothing
        Session("StatusChangeComment") = Nothing

        Response.Redirect("MessageBox.aspx")
    End Sub
End Class