﻿Public Class UserManager
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ' ログイン情報の取得
        Dim accountInfo As AccountInfo = DirectCast(Session("AccountInfo"), AccountInfo)

        ' ログイン情報がないとき
        If accountInfo Is Nothing Then
            Response.Redirect("Maintenance.aspx")
        End If

        ' 権限がないとき
        If Not accountInfo.roleUserManager Then
            Response.Redirect("Maintenance.aspx")
        End If

    End Sub

    ' ユーザデータの取得
    Private Sub GridViewBind(ByVal page As Integer)
        ' コネクションストリングの取得
        Dim connStr As String = Util.GetConnectionString
        ' データコンテキストの取得
        Dim dc As WebFormDBDataContext = New WebFormDBDataContext(connStr)
        ' モデルの宣言
        Dim model As DBModelUserMst = New DBModelUserMst

        ' ユーザデータの取得
        model.UserMst = From t In dc.GetTable(Of MstUser)() Select t
                             Order By t.OPERATOR_ID
                             Where (Me.operatorId.Text = "" OrElse t.OPERATOR_ID = Me.operatorId.Text)

        Me.userList.PageIndex = page
        Me.userList.PageSize = Util.GetAppSetting("PageSizeUserList")
        Me.userList.DataSource = model.UserMst
        Me.userList.DataBind()

    End Sub

    ' グリッドビューのページが切り替わったとき
    Private Sub userList_PageIndexChanging(sender As Object, e As System.Web.UI.WebControls.GridViewPageEventArgs) Handles userList.PageIndexChanging
        GridViewBind(e.NewPageIndex)
    End Sub

    ' 検索ボタンを押したとき
    Protected Sub search_Click(sender As Object, e As EventArgs) Handles search.Click
        GridViewBind(0)
    End Sub

    Protected Sub newUser_Click(sender As Object, e As EventArgs) Handles newUser.Click
        ' セッションのクリア
        Session("NewUserOperatorId") = Nothing
        Session("NewUserOperatorName") = Nothing
        Session("NewUserRole") = Nothing
        Session("NewUserPassword") = Nothing
        ' 新規ユーザ画面に繊維
        Response.Redirect("NewUser.aspx")
    End Sub

    ' カスタムバリデーション
    Private Sub CustomValidate_ServerValidate(ByVal source As System.Object, ByVal args As System.Web.UI.WebControls.ServerValidateEventArgs) Handles cusValOperatorId.ServerValidate
        Dim cusVal As CustomValidator = DirectCast(source, UI.WebControls.CustomValidator)

        If Me.operatorId.Text.Length > 10 Then
            args.IsValid = False
            cusVal.ErrorMessage = "オペレータIDは10文字以内で入力してください"
        End If
    End Sub
End Class